/* VAARALLISTA!  ... eli HAUSKAA (tiettyyn pisteeseen asti..). 
 *
 * Ei saa kokeilla yhteiskäyttökoneilla! Kotikoneella omalla
 * vastuulla.
 *
 * Tässäkin esimerkissä luodaan lapsiprosesseja niin kauan kuin
 * pystyy. Lisäksi uudelle prosessille kopioituu vanhempiprosessin
 * varaama muistialue. Tämä pistää siis järjestelmän polvilleen hyvin
 * nopeasti, kun fyysisestä muistista yksinkertaisesti loppuu tila.
 *
 * Tämä myös vastaa erääseen kysymykseen: Jos kerran fork() tekee
 * vanhempiprosessista ns. identtisen kopion, niin kopioituuko
 * muistialueetkin -- ja jos ne kopioituu, niin eikö tämä ole vallan
 * ylettömän raskas tapa tehdä prosesseja; eihän esim. shellissä
 * forkatussa lapsiprosessissa ajettava komento-ohjelma millään tavoin
 * tarvitse vanhempiprosessin dataa!
 *
 * Vastaus on fiksu systeemi nimeltä Copy-on-write. Käyttöjärjestelmän
 * muistinhallinta poimii tilanteet, joissa lapsiprosessi käyttää
 * vanhemmalta kloonattua muistialuetta. Se kopioidaan vanhemmalta
 * lapselle sivu kerrallaan aina, kun lapsi kirjoittaa jotakin
 * muistiin. Lopputuloksena: ei välttämättä kopioida muistia, jos
 * lapsi ei tarvitse sitä (esim. komennon suoritus exec():llä), mutta
 * kuitenkin toiminnallisessa mielessä lapsi todella on kopio
 * vanhemmasta, ja vieläpä identtinen. Niin kauan kuin muistia vain
 * luetaan (koodialuetta luetaan suoritettaessa aina), lapsen
 * virtuaaliosoite kartoittuu osoitteenmuodostuksessa samaan fyysisen
 * muistin sivuun kuin vanhemmankin. Eli kopioprosessin luomiseksi
 * tarvitsee olennaisesti vain alustaa uusi PCB.
 *
 */
#include<stdio.h>
#include<stdlib.h>

#include "turvavyo.h"

const int pgs = 100;  /*Näin monta sivua muistia aiotaan monistaa;
			voit kokeilla määrän vaikutusta...*/

int main(int argc, char *argv[]){
  int pid;
  int n = 0;
  char pikku_jononen[pgs*4096];
  int i;

  lopeta_jos_ei_turvallinen_kone();

  for(;;){
    switch (pid=fork()) {
    case 0: 
      /* Kirjoitetaan muistiin, jolloin Copy-on-write kopioi fyysisiä sivuja:*/
      for (i=0; i<pgs-1; i++){
        pikku_jononen[i*4096 + 1]= 'h';
      }
      /* Sitten jäädään odottamaan signaalia.*/
      pause();
      exit(0);
    case -1: 
      perror("fork() failed");
      break;
    default:
      printf("Tein lapsiprosessin, jonka PID on %d (yht. %d kpl) \r", pid, ++n);
    } 
  }
  return 0;
}
